SystemOrganization addCategory: #'Settings-Network'!

Object subclass: #NetworkSystemSettings
	instanceVariableNames: ''
	classVariableNames: 'BlabEmail LastHTTPProxyPort LastHTTPProxyServer ProxyPassword ProxyUser UseHTTPProxy UseNetworkAuthentification'
	poolDictionaries: ''
	category: 'Settings-Network'!

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/3/2009 07:19'!
blabEmail
	^ BlabEmail ifNil: [BlabEmail := '']! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/18/2009 07:37'!
blabEmail: aBlabEmailString
	BlabEmail := aBlabEmailString.
	self blabEmail 
		ifEmpty: [HTTPSocket blabEmail: '']
		ifNotEmpty: [HTTPSocket blabEmail: 'From: ', BlabEmail, ' <crlf>']! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 1/31/2010 17:07'!
httpProxyPort  
	^ HTTPSocket httpProxyPort! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/2/2009 07:34'!
httpProxyPort: aPort
	HTTPSocket httpProxyPort: aPort.
	LastHTTPProxyPort := HTTPSocket httpProxyPort.
! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/2/2009 07:33'!
httpProxyServer
	^ HTTPSocket httpProxyServer! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/2/2009 07:36'!
httpProxyServer: aServerName
	HTTPSocket httpProxyServer: aServerName.
	LastHTTPProxyServer := HTTPSocket httpProxyServer! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/9/2009 08:39'!
lastHTTPProxyPort
	^ LastHTTPProxyPort ifNil: [LastHTTPProxyPort := HTTPSocket httpProxyPort]. 
! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/2/2009 07:36'!
lastHTTPProxyServer
	^ LastHTTPProxyServer ifNil: [LastHTTPProxyServer := HTTPSocket httpProxyServer].
! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/8/2009 21:16'!
networkSettingsOn: aBuilder 
	<systemsettings> 
	(aBuilder group: #network) 
		label: 'Network' translated;
		description: 'All network related settings' translated;
		noOrdering;
		with: [ 
			(aBuilder setting: #useHTTPProxy)      
				label: 'Use HTTP proxy' translated;   
				noOrdering;
		 		description: 'If checked then the you will be able to set a port number and a server name. If unchecked, then no http proxy is used.' translated;
				with: [
					(aBuilder setting: #httpProxyPort)
						label: 'Port' translated;
						target: HTTPSocket;
						description: 'The HTTP proxy port'.
					(aBuilder setting: #httpProxyServer)
						label: 'Server' translated;
						target: HTTPSocket;
						description: 'The HTTP proxy server (i.e. proxy.univ-brest.fr)'].
			(aBuilder setting: #useNetworkAuthentification) 
				label: 'Use network authentification' translated;
				noOrdering;
		 		description: 'If checked then you will be able to enter a user name and a password for network authentification. Store  HTTP 1.0 basic authentication credentials. Note: this is an ugly hack that stores your password in your image.  It''s just enought to get you going if you use a firewall that requires authentication' translated;
				with: [
					(aBuilder setting: #proxyUser)
						label: 'User name' translated;
						description: 'The proxy user name' translated.
					(aBuilder setting: #proxyPassword)
						type: #Password;
						label: 'Password' translated;
						description: 'The user password' translated].
			(aBuilder setting: #blabEmail)
				label: 'Blab email' translated;
				ghostHelp: 'somebody@some.where';
				description: 'Enter blab email of the form ''somebody@some.where''. It can be empty' translated]! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/2/2009 23:03'!
proxyPassword
	| encoded stream |
	encoded := ProxyPassword ifNil: [ProxyPassword := ''].
	stream := ReadWriteStream on: (String new: 16).
	stream nextPutAll: encoded.
	^ (Base64MimeConverter mimeDecodeToChars: stream) contents.
! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/18/2009 07:36'!
proxyPassword: aPassword
	| stream passwd |
	passwd := aPassword ifNil: [''].
	stream := ReadWriteStream on: (String new: 16).
	stream nextPutAll: passwd.
	ProxyPassword := (Base64MimeConverter mimeEncode: stream) contents.
	HTTPSocket proxyUser: self proxyUser password: self proxyPassword
! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/2/2009 22:42'!
proxySettingsFileNameOn: aBuilder
	" not sure <systemsettings>"
	(aBuilder setting: #proxySettingsFileName)
			parent: #network;
			label: 'Proxy settings filename';
			target: HTTPSocket;
			type: #FilePath;
			description: 'The  server configuration file'! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 1/10/2010 09:35'!
proxySettingsFileNameSettingsOn: aBuilder
	" not sure <systemsettings>"
	(aBuilder setting: #proxySettingsFileName)
			parent: #network;
			label: 'Proxy settings filename';
			target: HTTPSocket;
			type: #FilePath;
			description: 'The  server configuration file'! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 1/10/2010 09:36'!
proxyUser
	| encoded stream |
	encoded := ProxyUser ifNil: [ProxyUser := ''].
	stream := ReadWriteStream on: (String new: 16). 
	stream nextPutAll: encoded.
	^ (Base64MimeConverter mimeDecodeToChars: stream) contents
! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/18/2009 07:35'!
proxyUser: aUser
	| stream userName |
	userName := aUser ifNil: [''].
	stream := ReadWriteStream on: (String new: 16).
	stream nextPutAll: userName.
	ProxyUser := (Base64MimeConverter mimeEncode: stream) contents.
	HTTPSocket proxyUser: self proxyUser password: self proxyPassword

! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/2/2009 07:23'!
useHTTPProxy
	^ UseHTTPProxy ifNil: [UseHTTPProxy := false]! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/18/2009 07:33'!
useHTTPProxy: aBoolean
	UseHTTPProxy = aBoolean ifTrue: [^self].
	UseHTTPProxy := aBoolean.
	self  useHTTPProxy
		ifTrue: [self httpProxyPort: self lastHTTPProxyPort .
			self httpProxyServer: self lastHTTPProxyServer]
		ifFalse: [HTTPSocket stopUsingProxyServer]
! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/3/2009 06:46'!
useNetworkAuthentification
	^ UseNetworkAuthentification ifNil: [UseNetworkAuthentification := false]! !

!NetworkSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 12/18/2009 07:34'!
useNetworkAuthentification: aBoolean
	UseNetworkAuthentification = aBoolean ifTrue: [^ self].
	UseNetworkAuthentification := aBoolean.
	self useNetworkAuthentification 
		ifTrue: [HTTPSocket proxyUser: self proxyUser password: self proxyPassword]
		ifFalse: [HTTPSocket proxyUser: '' password: '']! !
